type diff_term   = DiffVar of int * string
                 | DiffApp of diff_term * bunch
	         | DiffAbs of string * int * diff_term
	         | DiffStar
and bunch        = monomial list
and monomial     = (diff_term * int)

type var_degrees = int list

val make_degrees : int -> int -> var_degrees
val degrees_mult : int -> var_degrees -> var_degrees
val degrees_substract : var_degrees -> var_degrees -> var_degrees
val degrees_add : var_degrees -> var_degrees -> var_degrees
val degrees_eq : var_degrees -> var_degrees -> bool

val diff_eq : diff_term -> diff_term -> bool
val bunch_eq : bunch -> bunch -> bool
val bunch_divide : bunch -> monomial -> bunch
val monomial_bunch_mult : monomial -> bunch -> bunch
val bunch_mult : bunch -> bunch -> bunch
val bunch_power : bunch -> int -> bunch
val bunch_length : bunch -> int

val string_of_diff : diff_term -> string
val diff_of_string : string -> diff_term
val define_diff : string -> string -> unit
val define_dmacro : string -> string -> unit
