type lambda_term =
    Var of int * string
  | App of lambda_term * lambda_term
  | Abs of string * lambda_term
  | Star

val string_of_lambda : lambda_term -> string
val lambda_of_string : string -> lambda_term
val define_lambda : ?dont_normalize:bool -> string -> string -> unit
val define_macro : string -> string -> unit

val max_depth_limit : int
val normalize : lambda_term -> lambda_term
val exec : string -> string
